import java.util.StringTokenizer;
import java.util.GregorianCalendar;

/**
 * ́Eo̓G[`FbN
 * @version 1.0
 * @author kenta kikui
 */
 
public class ErrorCheck{
	//*********************************************************************************************
	// 萔̒`
	//*********************************************************************************************
	// GOOD_CHARS̐ύXꍇ́AGOOD_CHARS_NUMBERύX邱
	static final char[] GOOD_CHARS
			= {'!', '#', '$', '%', '&', '\'', '*', '+', '-', '/', '=', '?', '^', '_', '`', '{', '|', '}', '~', '.'};
	// GOOD_CHARS̐
	static final int GOOD_CHARS_NUMBER = 20;
	static final int DATE_YEAR_MIN = 1900;
	static final int DATE_YEAR_MAX = 2100;
	static final int DATE_MONTH_MIN = 1;
	static final int DATE_MONTH_MAX = 12;
	static final int DATE_DAY_MIN = 1;
	static final int DATE_DAY_MAX = 31;
	static final int DATE_DAY_MAX_SHORT = 30;
	static final int DATE_DAY_MAX_FEB = 28;
	static final int DATE_DAY_MAX_LEAP = 29;
	
	//*********************************************************************************************
	// ܂Łi萔̒`j
	//*********************************************************************************************
	
	public static void main(String[] args){
		//System.out.println(mailAddressFormatCheck(args[0]));
		//System.out.println(mailAddressFormatCheck("afefd"));
		//System.out.println(mailAddressFormatCheck((new Character('\\')).toString()));
		System.out.println(hankakuCheck(""));
	}
	
	/**
	 * ̌`FbN郁\bh
	 * @param str `FbNΏۂ̕
	 * @param min ̍ŏl
	 * @param max ̍ől
	 * @return boolean ̒min ȏAmaxȉłtrueԂBȊOfalseԂB
	 */
	public static boolean lengthCheck(String str, int min, int max){
		
		boolean checkFlg = false;
		
		if(min <= max){
			if( (str.length() >= min) && (str.length() <= max) ){
				checkFlg = true;
			}
		}
		
		return checkFlg;
	}
	
	/**
	 * 񂪔pǂ`FbN郁\bh
	 * @param str `FbNΏƂ̕
	 * @return boolean pȊO̕܂܂ĂꍇfalseԂ
	 */
	public static boolean hankakuCheck(String str){
		
		boolean checkFlg = false;
		byte[] bytes = str.getBytes();
		int len = str.length();
		StringBuffer sb = new StringBuffer(str);
		
		for (int i = 0; i < str.length(); i++) {
			if ('\n' == sb.charAt(i)) {
				len = len - 2;
			}
		}
		
		// lenƈ̃oCgꏏł΂ׂĔp
		if (len == bytes.length) {
			checkFlg = true;
		}
		
		return checkFlg;
	}
	
	/**
	 * 񂪔p݂̂ō\Ă邩`FbN郁\bh
	 * @param str `FbNΏƂ̕
	 * @return boolean ݂̂ō\ĂꍇTrueԂB
	 */
	public static boolean numberFormatCheck(String str){
		
		boolean checkFlg = true;
		char c;
		
		Check:
		for(int i=0; i < str.length(); i++){
			c = str.charAt(i);
			if( (c < '0') || (c > '9') ){
				checkFlg = false;
				break Check;
			}
		}
		
		return checkFlg;
	}
	
	/**
	 * 񂪔pAt@xbĝ݂ō\Ă邩`FbN郁\bh
	 * @param str ΏƂ̕
	 * @return boolean At@xbgȊO̕ofalseԂBȊOTrueԂB
	 */
	public static boolean alphabetFormatCheck(String str){
		
		boolean checkFlg = true;
		char c;
		
		Check:
		for(int i=0; i < str.length(); i++){
			c = str.charAt(i);
			if( (c < 'a' || c > 'z') && (c < 'A' || c > 'Z') ){
				checkFlg = false;
				break Check;
			}
		}
		
		return checkFlg;
	}
		
	/**
	 * E-mailŋĂ镶݂̂ŕ񂪍\Ă邩ʂ郁\bh
	 * Ă镶: ppƋĂL
	 * ĂL: ! # $ % & ' * + - / = ? ^ _ ` { | } ~ .
	 * @param str ΏƂ̕
	 * @return boolean ĂȂ񂪌ofalseԂBȊOTrueԂB
	 */
	public static boolean mailAddressFormatCheck(String str){
	
		boolean checkFlg1 = false;
		boolean checkFlg2 = true;
		char c;
		
		// ꕶ`FbN
		// ĂȂ1łoƃ[v𔲂o
		Check:
		for(int i=0; i < str.length(); i++){
			c = str.charAt(i);
			
			// p̏ꍇ
			if( hankakuCheck((new Character(c)).toString()) ) {
				// ƃAt@xbgȊȌꍇ(LH)
				if( (!numberFormatCheck((new Character(c)).toString())) && (!alphabetFormatCheck((new Character(c)).toString())) ){
				Check2:
					for(int j=0; j < GOOD_CHARS_NUMBER; j++){
						if(c == GOOD_CHARS[j]){
							checkFlg1 = true;
							break Check2;
						}
					}
					
					// ĂȂĂꍇ
					if(!checkFlg1){
						checkFlg2 = false;
						break Check;
					}
				}
			} else {
				// pȊȌꍇ
				checkFlg2 = false;
				break Check;
			}
		}
		
		return checkFlg2;
	}
	
	/**
	 * t̓͒lǂ`FbN郁\bh@iCׂ\bhFreturn)
	 * O
	 * 	1.@t̃tH[}bg"yyyy/mm/dd"ł邱
	 *  2.@̓`FbN͍sĂȂ
	 * @param str `FbNΏۂ̓tij
	 * @return boolean tƂĂ̓͒lꍇTrueAȂꍇFalseԂ
	 */
	public static boolean dateFormatCheck(String str){
		
		int tmpYear, tmpMonth, tmpDay;
		StringTokenizer tokenizer = new StringTokenizer(str, "/");
		String[] t = new String[3];
		
		//t܂܂Ă镶NEEɕ
		int cnt = 0;
		while(tokenizer.hasMoreTokens()){
			t[cnt] = tokenizer.nextToken();
			System.out.println(t[cnt]);
			cnt++;
		}
		tmpYear = Integer.valueOf(t[0]);
		tmpMonth = Integer.valueOf(t[1]);
		tmpDay = Integer.valueOf(t[2]);
		
		//*******************************************************
		// t͒l̃`FbN
		//*******************************************************
		
		//t̔N͈̔̓`FbN
		if( (tmpYear < DATE_YEAR_MIN) ||
			(tmpYear > DATE_YEAR_MAX) ){
				return false;
		}
		
		//ť͈̔͂̃`FbN
		if( (tmpMonth < DATE_MONTH_MIN) ||
			(tmpMonth > DATE_MONTH_MAX) ){
				return false;
		}
		
		GregorianCalendar gcal;
		switch(tmpMonth){
			case 2:
				// 邤Nł邩ǂ`FbN
				// 邤N̏ꍇ
				gcal = new GregorianCalendar();
				if(gcal.isLeapYear(tmpYear)){
					//邤N̏ꍇA229܂łɂȂ
						if( (tmpDay < DATE_DAY_MIN) ||
							(tmpDay > DATE_DAY_MAX_LEAP) ){
								return false;
						}
				} else {
					// N̏ꍇ
					if( (tmpDay < DATE_DAY_MIN) ||
						(tmpDay > DATE_DAY_MAX_FEB) ){
								return false;
					}
				}
				break;
				
			case 4:
			case 6:
			case 9:
			case 11:
				if( (tmpDay < DATE_DAY_MIN) ||
					(tmpDay > DATE_DAY_MAX_SHORT) ){
						return false;
				}
				break;
				
			default:
				if( (tmpDay < DATE_DAY_MIN) ||
					(tmpDay > DATE_DAY_MAX) ){
						return false;
				}
		}
		
		return true;
	}
}
